//+------------------------------------------------------------------+
//|                                               delete_pending.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property show_confirm

#include <WinUser32.mqh>
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| script "delete first pending order"                              |
//+------------------------------------------------------------------+
int start()
  {
   bool   result;
   int    cmd,total,err;
//----
   total=OrdersTotal();
//----
   for(int i=0; i<total; i++)
   {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
    {
     if (OrderSymbol()!=Symbol()) continue; // delete orders on current chart only
      
     cmd=OrderType();
     //---- pending orders only are considered
     if(cmd!=OP_BUY && cmd!=OP_SELL)
     {
      //---- print selected order
      OrderPrint();
      //---- delete first pending order
      result=OrderDelete(OrderTicket());
      if(result!=TRUE) {
        err = GetLastError();
        Alert("Error when OrderDelete()",err," : ",ErrorDescription(err));
        break;
      }
     }
    } else {
      err = GetLastError();
      Alert("Error when order select ",err," : ",ErrorDescription(err));
      break; 
    }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+